## vlfeat 0.9.17+dfsg0

=== Makefile ===
# file: Makefile
# description: Build everything
# author: Andrea Vedaldi

# Copyright (C) 2007-12 Andrea Vedaldi and Brian Fulkerson.
# All rights reserved.
#
# This file is part of the VLFeat library and is made available under
# the terms of the BSD license (see the COPYING file).

# VLFEAT BUILDING INSTRUCTIONS
#
# This makefile builds VLFeat on modern UNIX boxes with the GNU
# toolchain. Mac OS X and Linux are explicitly supported, and support
# for similar architectures can be easily added.
#
# Usually, compiling VLFeat reduces to typing
#
# > cd PATH_TO_VLFEAT_SOURCE_TREE
# > make
#
# The makefile attempts to automatically determine the host
# architecture. If this fails, or if the architecture is ambiguous,
# the architecture can be set by specifying the ARCH variable. For
# instance:
#
# > make ARCH=maci64
#
# builds VLFeat for Mac OS X Intel 64 bit.
#
# !! Unforunately MATLAB mex script (at least up to version 2009B) has
# !! a bug that prevents selecting an architecture different from the
# !! default one for compilation. For instance, compiling maci64 may
# !! not work as the default architecture is maci if both 32 and 64
# !! bit MATLAB are installed. This bug is easy to fix, but requires
# !! patching the mex script. See www.vlfeat.org for detailed
# !! instructions.
#
# Other useful variables are listed below (their default value is in
# square bracked).
#
#   ARCH [undefined] - Active architecture. The supported
#       architectures are maci, maci64, glnx86, or glnxa64 (these are
#       the same architecture identifers used by MATLAB:
#       http://www.mathworks.com/help/techdoc/ref/computer.html). If
#       undefined, the makefile attempts to automatically detect the
#       architecture.
#
#   DEBUG [undefined] - If defined, turns on debugging symbols and
#       turns off optimizations
#
#   PROFILE [undefined] - If defined, turns on debugging symbols but
#       does NOT turn off optimizations.
#
#   VERB [undefined] - If defined, display in full the command
#       executed and their output.
#
#   MEX [mex]- Path to MATLAB MEX compiler. If undefined, MATLAB supprot
#       is disabled.
#
#   MKOCTFILE [undefined] - Path to Octave MKOCTFILE compiler. If undefined,
#       Octave support is disabled.
#
# To completely remove all build products use
#
# > make distclean
#
# Other useful targets include:
#
#   clean - Removes intermediate build products for the active architecture.
#   archclean - Removes all build products for the active architecture.
#   distclean - Removes all build products.
#   info - Display a list of the variables defined by the Makefile.
#   help - Print this message.
#
# VLFeat is compsed of different parts (DLL, command line utilities,
# MATLAB interface, Octave interface) so the makefile is divided in
# components, located in make/*.mak. Please check out the
# corresponding files in order to adjust parameters.

# Copyright (C) 2007-13 Andrea Vedaldi and Brian Fulkerson.
# All rights reserved.
#
# This file is part of the VLFeat library and is made available under
# the terms of the BSD license (see the COPYING file).

SHELL = /bin/bash

.PHONY : all
all:

# Select which features to disable
# DISABLE_SSE2=yes
# DISABLE_AVX=yes
# DISABLE_THREADS=yes
# DISABLE_OPENMP=yes

# --------------------------------------------------------------------
#                                                       Error Messages
# --------------------------------------------------------------------

err_no_arch  =
err_no_arch +=$(shell echo "** Unknown host architecture '$(UNAME)'. This identifier"   1>&2)
err_no_arch +=$(shell echo "** was obtained by running 'uname -sm'. Edit the Makefile " 1>&2)
err_no_arch +=$(shell echo "** to add the appropriate configuration."                   1>&2)
err_no_arch +=config

err_internal  =$(shell echo Internal error)
err_internal +=internal

err_spaces  = $(shell echo "** VLFeat root dir VLDIR='$(VLDIR)' contains spaces."  1>&2)
err_spaces += $(shell echo "** This is not supported due to GNU Make limitations." 1>&2)
err_spaces +=spaces

# --------------------------------------------------------------------
#                                             Auto-detect architecture
# --------------------------------------------------------------------

Darwin_PPC_ARCH := mac
Darwin_Power_Macintosh_ARCH := mac
Darwin_i386_ARCH := maci64
Darwin_x86_64_ARCH := maci64
Linux_i386_ARCH := glnx86
Linux_i686_ARCH := glnx86
Linux_unknown_ARC := glnx86
Linux_x86_64_ARCH := glnxa64

UNAME := $(shell uname -sm)
ARCH ?= $($(shell echo "$(UNAME)" | tr \  _)_ARCH)

# sanity check
ifeq ($(ARCH),)
die:=$(error $(err_no_arch))
endif

ifneq ($(VLDIR),$(shell echo "$(VLDIR)" | sed 's/ //g'))
die:=$(error $(err_spaces))
endif

# --------------------------------------------------------------------
#                                                        Configuration
# --------------------------------------------------------------------

VLDIR ?= .
LIBTOOL ?= libtool

STD_CLFAGS = $(CFLAGS)
STD_CFLAGS += -std=c99
STD_CFLAGS += -Wall -Wextra

STD_CFLAGS += -Wno-unused-function -Wno-long-long -Wno-variadic-macros
STD_CFLAGS += $(if $(DISABLE_THREADS), -DVL_DISABLE_THREADS)
STD_CFLAGS += $(if $(DISABLE_SSE2), -DVL_DISABLE_SSE2)
STD_CFLAGS += $(if $(DISABLE_OPENMP), -DVL_DISABLE_OPENMP)
STD_CFLAGS += $(if $(DEBUG), -DDEBUG -O0 -g, -DNDEBUG -O3)
STD_CFLAGS += $(if $(DISABLE_AVX), -DVL_DISABLE_AVX)
STD_CFLAGS += $(if $(PROFILE), -g)

STD_LDFLAGS = $(LDFLAGS)

# Architecture specific ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

# Mac OS X Intel 32
ifeq ($(ARCH),maci)
#SDKROOT ?= $(shell xcode-select -print-path)/Platforms/MacOSX.platform/Developer/SDKs/MacOSX10.7.sdk
SDKROOT ?= $(shell xcodebuild -version -sdk macosx | sed -n '/^Path\:/p' | sed 's/^Path: //')
MACOSX_DEPLOYMENT_TARGET ?= 10.4
STD_CFLAGS += -m32 -isysroot $(SDKROOT) -mmacosx-version-min=$(MACOSX_DEPLOYMENT_TARGET)
STD_LDFLAGS += -Wl,-syslibroot,$(SDKROOT) -mmacosx-version-min=$(MACOSX_DEPLOYMENT_TARGET)
DISABLE_AVX ?= yes
CC = gcc
endif

# Mac OS X Intel 64
ifeq ($(ARCH),maci64)
#SDKROOT ?= $(shell xcode-select -print-path)/Platforms/MacOSX.platform/Developer/SDKs/MacOSX10.7.sdk
SDKROOT ?= $(shell xcodebuild -version -sdk macosx | sed -n '/^Path\:/p' | sed 's/^Path: //')
MACOSX_DEPLOYMENT_TARGET ?= 10.4
STD_CFLAGS += -m64 -isysroot $(SDKROOT) -mmacosx-version-min=$(MACOSX_DEPLOYMENT_TARGET)
STD_LDFLAGS += -Wl,-syslibroot,$(SDKROOT) -mmacosx-version-min=$(MACOSX_DEPLOYMENT_TARGET)
DISABLE_AVX ?= yes # GCC 4.2 need for OpenMP does not support -mavx
CC = gcc
endif

# Linux-32
ifeq ($(ARCH),glnx86)
# Target compatibility with GLIBC 2.3.4
# 1) _GNU_SOURCE avoids using isoc99_fscanf, limiting binray portability to recent GLIBC.
# 2) -fno-stack-protector avoids using a feature requiring GLBIC 2.4
STD_CFLAGS += -m32 -D_GNU_SOURCE -fno-stack-protector
STD_LDFLAGS += -m32 -Wl,--rpath,\$$ORIGIN/ -Wl,--as-needed -lpthread -lm
CC ?= gcc
endif

# Linux-64
ifeq ($(ARCH),glnxa64)
STD_CFLAGS += -D_GNU_SOURCE -fno-stack-protector
STD_LDFLAGS += -Wl,--rpath,\$$ORIGIN/ -Wl,--as-needed -lpthread -lm
CC ?= gcc
endif

# --------------------------------------------------------------------
#                                                            Functions
# --------------------------------------------------------------------

# $(call if-like,FILTER,WHY,WHAT)
define if-like
$(if $(filter $(1),$(2)),$(3))
endef

# $(call dump-var,VAR) pretty-prints the content of a variable VAR on
# multiple columns
ifdef VERB
define dump-var
@echo "$(1) ="
@echo "$($(1))" | sed 's/\([^ ][^ ]* [^ ][^ ]*\) */\1#/g' | \
tr '#' '\n' | column -t | sed 's/\(.*\)/  \1/g'
endef
else
define dump-var
@printf "%15s = %s\n" "$(1)" \
"$$(echo '$($(1))' | sed -e 's/[^ ][^ ]* /\.\.\./3' -e 's/\.\.\..*$$/\.\.\./g')"
endef
endif

# $(call echo-var,VAR) pretty-prints the content of a variable VAR on
# one line
define echo-var
@printf "%15s = %s\n" "$(1)" "$($(1))"
endef

# $(call echo-title,TITLE) pretty-prints TITLE as a title
define echo-title
@printf "** %s\n" "$(1)"
endef

# $(call print-command, CMD, TGT) prints a message
define print-command
@printf "%15s %s\n" "$(strip $(1))" "$(strip $(2))"
endef

# $(call C, CMD) runs $(CMD) silently
define C
@$(call print-command, $(1), "$(@)")
@quiet ()                                                            \
{                                                                    \
    local cmd out err ;					             \
    cmd="$($(1))";                                                   \
    out=$$($${cmd} "$${@}" 2>&1) ;                                   \
    err=$${?} ;                                                      \
    if test $${err} -gt 0 ; then                                     \
        echo "******* Offending Command:";                           \
        printf "%s" "$${cmd}" ;                                      \
	for i in "$${@}" ; do printf " '%s'" "$$i" ; done ;          \
	echo ;                                                       \
        echo "******* Error Code: $${err}";                          \
	echo "******* Command Output:";                              \
        echo "$${out}";                                              \
    fi;                                                              \
    echo "$${out}" | grep [Ww]arning ;                               \
    return $${err};                                                  \
} ; quiet
endef

# If verbose print everything
ifdef VERB
C = $($(1))
endif

# rule to create a directory
.PRECIOUS: %/.dirstamp
%/.dirstamp :
	@printf "%15s %s\n" MK "$(dir $@)"
	@mkdir -p $(dir $@)
	@echo "Directory generated by make." > $@

# $(call gendir, TARGET, DIR1 DIR2 ...) creates a target TARGET-dir that
# triggers the creation of the directories DIR1, DIR2
define gendir
$(1)-dir=$(foreach x,$(2),$(x)/.dirstamp)
endef

# --------------------------------------------------------------------
#                                                                Build
# --------------------------------------------------------------------

# Each Makefile submodule appends appropriate dependencies to the all,
# clean, archclean, distclean, and info targets. In addition, it
# appends to the deps and bins variables the list of .d files (to be
# inclued by make as auto-dependencies) and the list of files to be
# added to the binary distribution.

include make/dll.mak
include make/bin.mak
include make/matlab.mak
include make/octave.mak
include make/doc.mak
include make/dist.mak

.PHONY: clean, archclean, distclean, info, help
no_dep_targets += clean archclean distclean info help

clean:
	rm -f  `find . -name '*~'`
	rm -f  `find . -name '.DS_Store'`
	rm -f  `find . -name '.gdb_history'`
	rm -f  `find . -name '._*'`
	rm -rf ./results

archclean: clean

distclean:

info:
	$(call echo-title,General settings)
	$(call dump-var,deps)
	$(call echo-var,PROFILE)
	$(call echo-var,DEBUG)
	$(call echo-var,VER)
	$(call echo-var,ARCH)
	$(call echo-var,CC)
	$(call echo-var,STD_CFLAGS)
	$(call echo-var,STD_LDFLAGS)
	$(call echo-var,DISABLE_SSE2)
	$(call echo-var,DISABLE_AVX)
	$(call echo-var,DISABLE_THREADS)
	$(call echo-var,DISABLE_OPENMP)
	@printf "\nThere are %s lines of code.\n" \
	`cat $(m_src) $(mex_src) $(dll_src) $(dll_hdr) $(bin_src) | wc -l`

# Holw help works: cat this file,
# skip the first block until an empty line is found (twice)
# print the first block until an empty line,
# remove the `# ' prefix from each remaining line

help:
	@cat Makefile | \
	sed -n '1,/^$$/!p' | \
	sed -n '1,/^$$/!p' | \
	sed -n '1,/^$$/p' | \
	sed 's/^# \{0,1\}\(.*\)$$/\1/'

# --------------------------------------------------------------------
#                                                 Include dependencies
# --------------------------------------------------------------------

.PRECIOUS: $(deps)

ifeq ($(filter $(no_dep_targets), $(MAKECMDGOALS)),)
-include $(deps)
endif

=== debian/changelog ===
vlfeat (0.9.17+dfsg0-6build1) trusty; urgency=medium

  * Rebuild for octave 3.8.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 24 Feb 2014 23:50:55 +0000

vlfeat (0.9.17+dfsg0-6) unstable; urgency=low

  * Bug fix: "Do not compress the example *.m files", thanks to Rafael
    Laboissiere (Closes: #734049).

 -- Dima Kogan <dima@secretsauce.net>  Sun, 12 Jan 2014 01:56:11 -0800

vlfeat (0.9.17+dfsg0-5) unstable; urgency=low

  * vlfeat is now Multi-arch:same

 -- Dima Kogan <dima@secretsauce.net>  Sat, 28 Dec 2013 00:15:39 -0800

vlfeat (0.9.17+dfsg0-4) unstable; urgency=low

  * Build fixes to work on a wider array of machines:

    - No longer using SSE or AVX, since the target may not have those
    - No longer building x86-specific code on non-x86 boxes

 -- Dima Kogan <dima@secretsauce.net>  Mon, 23 Dec 2013 13:35:09 -0800

vlfeat (0.9.17+dfsg0-3) unstable; urgency=low

  * libvlfeat-doc no longer ships intermediate build files

 -- Dima Kogan <dima@secretsauce.net>  Sun, 22 Dec 2013 21:02:49 -0800

vlfeat (0.9.17+dfsg0-2) unstable; urgency=low

  * Stripped Google Adsense and Google custom search from the packaged
    docs

 -- Dima Kogan <dima@secretsauce.net>  Sun, 22 Dec 2013 12:54:16 -0800

vlfeat (0.9.17+dfsg0-1) unstable; urgency=low

  * Initial Debian release (Closes: #576124)

 -- Dima Kogan <dima@secretsauce.net>  Wed, 06 Nov 2013 22:55:35 -0800

=== debian/control ===
Source: vlfeat
Section: science
Priority: optional
Build-Depends: debhelper (>= 9), dh-exec, liboctave-dev, octave-pkg-dev (>= 1.0.0),
               transfig, ghostscript, inkscape, texlive-latex-base, imagemagick,
               python2.7, doxygen, rsync
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Dima Kogan <dima@secretsauce.net>
Standards-Version: 3.9.4
Homepage: http://www.vlfeat.org
Vcs-Git: git://anonscm.debian.org/debian-science/packages/vlfeat.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/vlfeat.git

Package: libvlfeat0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Computer vision library focussing on visual features and clustering
 VLFeat implements popular computer vision algorithms including SIFT, MSER,
 k-means, hierarchical k-means, agglomerative information bottleneck, and quick
 shift. It is written in C for efficiency and compatibility, with interfaces in
 GNU octave for ease of use, and detailed documentation throughout

Package: libvlfeat-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, libvlfeat0 (= ${binary:Version})
Recommends: libvlfeat-doc
Description: Computer vision library focussing on visual features and clustering
 VLFeat implements popular computer vision algorithms including SIFT, MSER,
 k-means, hierarchical k-means, agglomerative information bottleneck, and quick
 shift. It is written in C for efficiency and compatibility, with interfaces in
 GNU octave for ease of use, and detailed documentation throughout
 .
 Development files

Package: libvlfeat0-dbg
Section: debug
Priority: extra
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libvlfeat0 (= ${binary:Version})
Description: Computer vision library focussing on visual features and clustering
 VLFeat implements popular computer vision algorithms including SIFT, MSER,
 k-means, hierarchical k-means, agglomerative information bottleneck, and quick
 shift. It is written in C for efficiency and compatibility, with interfaces in
 GNU octave for ease of use, and detailed documentation throughout
 .
 Debug symbols

Package: libvlfeat-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Computer vision library focussing on visual features and clustering
 VLFeat implements popular computer vision algorithms including SIFT, MSER,
 k-means, hierarchical k-means, agglomerative information bottleneck, and quick
 shift. It is written in C for efficiency and compatibility, with interfaces in
 GNU octave for ease of use, and detailed documentation throughout
 .
 Documentation

Package: octave-vlfeat
Section: libs
Priority: extra
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, libvlfeat0 (>= ${binary:Version}),
         ${octave:Depends}
Recommends: libvlfeat-doc
Description: Computer vision library focussing on visual features and clustering
 VLFeat implements popular computer vision algorithms including SIFT, MSER,
 k-means, hierarchical k-means, agglomerative information bottleneck, and quick
 shift. It is written in C for efficiency and compatibility, with interfaces in
 GNU octave for ease of use, and detailed documentation throughout
 .
 GNU Octave interface

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# grab the version from the debian changelog
VERSION := $(shell sed -n 's/.*(\([0-9\.]*[0-9]\).*).*/\1/;; p; q;' debian/changelog)

# grab the API version from the library SONAME
API_VERSION = $(shell objdump -p bin/*/libvl.so | perl -ne 'if(/^\s+SONAME\s+libvl.so./p) {print $${^POSTMATCH}; exit;}')

%:
	dh $@

override_dh_auto_build:
	make MKOCTFILE=`which mkoctfile` VERB=1 CFLAGS+=-g all doc


override_dh_auto_install: $(addprefix install/,data $(wildcard toolbox/*))
	cp bin/*/libvl.so libvl.so.$(VERSION)
	ln -fs libvl.so.$(VERSION) libvl.so
	ln -fs libvl.so.$(VERSION) libvl.so.$(API_VERSION)

override_dh_gencontrol:
	dh_gencontrol -- -V"octave:Depends=octave(>=`octave-config --print VERSION`)"

override_dh_strip: strip_mex
	dh_strip --dbg-package=libvlfeat0-dbg

override_dh_installdocs:
	dh_installdocs -Xbuild/

override_dh_auto_clean:
	dh_auto_clean
	rm -f libvl.so*




# The rest is all for octave. There's some CDBS infrastructure to automate this,
# but it's designed for octave-only source packages. I have both in one source,
# so I can't use it

include /usr/share/octave/debian/defs.make


# I want to take all the *.m in toolbox/xxx/ for all xxx except mex and
# noprefix. I want to take only some particular toolbox/*.m. There are many
# other files strewn around that I want to ignore. This is somewhat
# convoluted...

OCTAVE_MPATH   := debian/octave-vlfeat$(MDIR)/vlfeat/toolbox
OCTAVE_BINPATH := debian/octave-vlfeat$(OCTDIR)/vlfeat/toolbox
OCTAVE_PHONY_TARGETS := $(addprefix install/,data $(wildcard toolbox/*) toolbox/mex toolbox/noprefix)
.PHONY: $(OCTAVE_PHONY_TARGETS)

OCT_TARGET=$(@:install/%=%)

$(addprefix install/toolbox/, vl_harris.m vl_help.m vl_root.m):
	install -d $(OCTAVE_MPATH)
	install -m 0644 $(OCT_TARGET) $(OCTAVE_MPATH)

# installing the .mex files with executable bits set to let dh_shlibdeps index
# them. I remove these bits as soon as dh_shlibdeps does its thing
install/toolbox/mex:
	install -d $(OCTAVE_BINPATH)
	install -m 0755 $(OCT_TARGET)/*/*/*.mex $(OCTAVE_BINPATH)

override_dh_shlibdeps:
	dh_shlibdeps
	chmod 0644 $(OCTAVE_BINPATH)/*.mex

override_dh_compress:
	dh_compress -X.m

$(filter-out %.m install/data install/toolbox/mex install/toolbox/noprefix,$(OCTAVE_PHONY_TARGETS)):
	if [ -d $(OCT_TARGET) ]; then							\
		install -d $(OCTAVE_MPATH);						\
		install -d $(OCTAVE_MPATH)/$(notdir $(OCT_TARGET));			\
		install -m 0644 $(OCT_TARGET)/*.m $(OCTAVE_MPATH)/$(notdir $(OCT_TARGET));	\
	fi

install/data:
	install -d $(OCTAVE_MPATH)/../data
	install -m 0644 data/* $(OCTAVE_MPATH)/../data

# dh_strip doesn't see the .mex files as needing stripping, so I do it myself
.PHONY: strip_mex
strip_mex:
	strip --remove-section=.comment --remove-section=.note --strip-unneeded $(OCTAVE_BINPATH)/*.mex

## vlfeat 0.9.20+dfsg0

=== Makefile ===
--- 
+++ 
@@ -2,6 +2,7 @@
 # description: Build everything
 # author: Andrea Vedaldi
 
+# Copyright (C) 2014 Andrea Vedaldi.
 # Copyright (C) 2007-12 Andrea Vedaldi and Brian Fulkerson.
 # All rights reserved.
 #
@@ -10,11 +11,9 @@
 
 # VLFEAT BUILDING INSTRUCTIONS
 #
-# This makefile builds VLFeat on modern UNIX boxes with the GNU
-# toolchain. Mac OS X and Linux are explicitly supported, and support
-# for similar architectures can be easily added.
-#
-# Usually, compiling VLFeat reduces to typing
+# This makefile builds VLFeat on standard Unix installations with the
+# GNU toolchain. Mac OS X and GNU-Linux are explicitly
+# supported. Usually, compiling VLFeat reduces to typing
 #
 # > cd PATH_TO_VLFEAT_SOURCE_TREE
 # > make
@@ -26,40 +25,46 @@
 #
 # > make ARCH=maci64
 #
-# builds VLFeat for Mac OS X Intel 64 bit.
-#
-# !! Unforunately MATLAB mex script (at least up to version 2009B) has
-# !! a bug that prevents selecting an architecture different from the
-# !! default one for compilation. For instance, compiling maci64 may
-# !! not work as the default architecture is maci if both 32 and 64
-# !! bit MATLAB are installed. This bug is easy to fix, but requires
-# !! patching the mex script. See www.vlfeat.org for detailed
-# !! instructions.
+# builds VLFeat for Mac OS X Intel 64 bit. Pease
+# see http://www.vlfeat.org/compiling.html
+# for troubleshooting and details.
 #
 # Other useful variables are listed below (their default value is in
-# square bracked).
-#
-#   ARCH [undefined] - Active architecture. The supported
+# square brackets).
+#
+#   ARCH [not defined] - Active architecture. The supported
 #       architectures are maci, maci64, glnx86, or glnxa64 (these are
-#       the same architecture identifers used by MATLAB:
+#       the same architecture identifiers used by MATLAB:
 #       http://www.mathworks.com/help/techdoc/ref/computer.html). If
 #       undefined, the makefile attempts to automatically detect the
 #       architecture.
 #
-#   DEBUG [undefined] - If defined, turns on debugging symbols and
+#   DEBUG [not defined] - If defined, turns on debugging symbols and
 #       turns off optimizations
 #
-#   PROFILE [undefined] - If defined, turns on debugging symbols but
+#   PROFILE [not defined] - If defined, turns on debugging symbols but
 #       does NOT turn off optimizations.
 #
-#   VERB [undefined] - If defined, display in full the command
+#   VERB [not defined] - If defined, display in full the command
 #       executed and their output.
 #
-#   MEX [mex]- Path to MATLAB MEX compiler. If undefined, MATLAB supprot
+#   MEX [mex]- Path to MATLAB MEX compiler. If undefined, MATLAB support
 #       is disabled.
 #
-#   MKOCTFILE [undefined] - Path to Octave MKOCTFILE compiler. If undefined,
+#   MKOCTFILE [not defined] - Path to Octave MKOCTFILE compiler. If undefined,
 #       Octave support is disabled.
+#
+# If defined to anything other than "no", the following falgs disable
+# specific features in the library. By defaults, all the features are
+# enabled.  If the makefile finds that the environment is unable to
+# support some of them, it may decide to disable them automatically
+# (in this case it will print a message).  This behaviour can be
+# overriden by defining the flag to be "no".
+#
+#   DISABLE_SSE2 - SSE2 vector instructions support.
+#   DISABLE_AVX - AVX vector instructions support.
+#   DISABLE_THREADS - Supprot for multithreded library client.
+#   DISABLE_OPENMP - OpenMP-based multithreaded computations.
 #
 # To completely remove all build products use
 #
@@ -78,6 +83,7 @@
 # components, located in make/*.mak. Please check out the
 # corresponding files in order to adjust parameters.
 
+# Copyright (C) 2014 Andrea Vedaldi.
 # Copyright (C) 2007-13 Andrea Vedaldi and Brian Fulkerson.
 # All rights reserved.
 #
@@ -122,7 +128,7 @@
 Darwin_x86_64_ARCH := maci64
 Linux_i386_ARCH := glnx86
 Linux_i686_ARCH := glnx86
-Linux_unknown_ARC := glnx86
+Linux_unknown_ARCH := glnx86
 Linux_x86_64_ARCH := glnxa64
 
 UNAME := $(shell uname -sm)
@@ -147,56 +153,97 @@
 STD_CLFAGS = $(CFLAGS)
 STD_CFLAGS += -std=c99
 STD_CFLAGS += -Wall -Wextra
-
 STD_CFLAGS += -Wno-unused-function -Wno-long-long -Wno-variadic-macros
-STD_CFLAGS += $(if $(DISABLE_THREADS), -DVL_DISABLE_THREADS)
-STD_CFLAGS += $(if $(DISABLE_SSE2), -DVL_DISABLE_SSE2)
-STD_CFLAGS += $(if $(DISABLE_OPENMP), -DVL_DISABLE_OPENMP)
 STD_CFLAGS += $(if $(DEBUG), -DDEBUG -O0 -g, -DNDEBUG -O3)
-STD_CFLAGS += $(if $(DISABLE_AVX), -DVL_DISABLE_AVX)
 STD_CFLAGS += $(if $(PROFILE), -g)
 
 STD_LDFLAGS = $(LDFLAGS)
 
 # Architecture specific ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
-# Mac OS X Intel 32
-ifeq ($(ARCH),maci)
-#SDKROOT ?= $(shell xcode-select -print-path)/Platforms/MacOSX.platform/Developer/SDKs/MacOSX10.7.sdk
-SDKROOT ?= $(shell xcodebuild -version -sdk macosx | sed -n '/^Path\:/p' | sed 's/^Path: //')
+# Detect compiler
+COMPILER_VER_STRING:=$(shell $(CC) --version) $(shell $(CC) -v 2>&1)
+COMPILER:=other
+
+ifneq ($(shell echo "$(COMPILER_VER_STRING)" | grep "gcc"),)
+COMPILER:=gcc
+COMPILER_VER:=$(shell \
+$(CC) -dumpversion | \
+sed -e 's/\.\([0-9][0-9]\)/\1/g' \
+    -e 's/\.\([0-9]\)/0\1/g' \
+    -e 's/^[0-9]\{3,4\}$$/&00/' )
+endif
+
+ifeq "$(findstring clang,$(COMPILER_VER_STRING))" "clang"
+COMPILER:=clang
+COMPILER_VER:=$(shell \
+echo "$(COMPILER_VER_STRING)" | \
+sed -n -e 's/.*version *\([0-9.][0-9.]*\).*/\1/p;' | \
+sed -e 's/\.\([0-9][0-9]\)/\1/g' \
+    -e 's/\.\([0-9]\)/0\1/g' \
+    -e 's/^[0-9]\{3,4\}$$/&00/' )
+endif
+
+$(info Detected compiler: $(COMPILER) $(COMPILER_VER))
+ifeq "$(COMPILER_VER)" "other"
+$(warning Unsupported compiler detected, use at your own risk!)
+endif
+
+ifeq "$(COMPILER)" "gcc"
+ifeq "$(shell expr $(COMPILER_VER) \<= 40600)" "1"
+ifneq "$(DISABLE_AVX)" "no"
+$(info GCC <= 4.6.0 detected, disabling AVX.)
+DISABLE_AVX:=yes
+endif
+endif
+endif
+
+ifeq "$(COMPILER)" "clang"
+ifneq "$(DISABLE_OPENMP)" "no"
+$(info Clang does not support OpenMP yet, disabling.)
+DISABLE_OPENMP:=yes
+endif
+endif
+
+# Mac OS X Intel
+ifeq "$(ARCH)" "$(filter $(ARCH),maci maci64)"
+ifeq "$(ARCH)" "maci"
+march=32
+else
+march=64
+endif
+SDKROOT ?= $(shell xcrun -sdk macosx --show-sdk-path)
 MACOSX_DEPLOYMENT_TARGET ?= 10.4
-STD_CFLAGS += -m32 -isysroot $(SDKROOT) -mmacosx-version-min=$(MACOSX_DEPLOYMENT_TARGET)
+STD_CFLAGS += -m$(march) -isysroot $(SDKROOT) -mmacosx-version-min=$(MACOSX_DEPLOYMENT_TARGET)
 STD_LDFLAGS += -Wl,-syslibroot,$(SDKROOT) -mmacosx-version-min=$(MACOSX_DEPLOYMENT_TARGET)
-DISABLE_AVX ?= yes
-CC = gcc
-endif
-
-# Mac OS X Intel 64
-ifeq ($(ARCH),maci64)
-#SDKROOT ?= $(shell xcode-select -print-path)/Platforms/MacOSX.platform/Developer/SDKs/MacOSX10.7.sdk
-SDKROOT ?= $(shell xcodebuild -version -sdk macosx | sed -n '/^Path\:/p' | sed 's/^Path: //')
-MACOSX_DEPLOYMENT_TARGET ?= 10.4
-STD_CFLAGS += -m64 -isysroot $(SDKROOT) -mmacosx-version-min=$(MACOSX_DEPLOYMENT_TARGET)
-STD_LDFLAGS += -Wl,-syslibroot,$(SDKROOT) -mmacosx-version-min=$(MACOSX_DEPLOYMENT_TARGET)
-DISABLE_AVX ?= yes # GCC 4.2 need for OpenMP does not support -mavx
-CC = gcc
-endif
-
-# Linux-32
-ifeq ($(ARCH),glnx86)
+endif
+
+# Linux
+ifeq "$(ARCH)" "$(filter $(ARCH),glnx86 glnxa64)"
+ifeq "$(ARCH)" "glnx86"
+march=32
+else
+march=64
+endif
 # Target compatibility with GLIBC 2.3.4
-# 1) _GNU_SOURCE avoids using isoc99_fscanf, limiting binray portability to recent GLIBC.
+# 1) _GNU_SOURCE avoids using isoc99_fscanf, limiting binary portability to recent GLIBC.
 # 2) -fno-stack-protector avoids using a feature requiring GLBIC 2.4
-STD_CFLAGS += -m32 -D_GNU_SOURCE -fno-stack-protector
-STD_LDFLAGS += -m32 -Wl,--rpath,\$$ORIGIN/ -Wl,--as-needed -lpthread -lm
-CC ?= gcc
-endif
-
-# Linux-64
-ifeq ($(ARCH),glnxa64)
-STD_CFLAGS += -D_GNU_SOURCE -fno-stack-protector
-STD_LDFLAGS += -Wl,--rpath,\$$ORIGIN/ -Wl,--as-needed -lpthread -lm
-CC ?= gcc
+STD_CFLAGS += -m$(march) -D_GNU_SOURCE -fno-stack-protector
+STD_LDFLAGS += -m$(march) -Wl,--rpath,\$$ORIGIN/ -Wl,--as-needed
+endif
+
+# Convert back DISALBE_*="no" flags to be empty
+ifeq "$(DISABLE_SSE2)" "no"
+override DISABLE_SSE2:=
+endif
+ifeq "$(DISABLE_AVX)" "no"
+override DISABLE_AVX:=
+endif
+ifeq "$(DISABLE_THREADS)" "no"
+override DISABLE_THREADS:=
+endif
+ifeq "$(DISABLE_OPENMP)" "no"
+override DISABLE_OPENMP:=
 endif
 
 # --------------------------------------------------------------------
@@ -226,46 +273,30 @@
 # $(call echo-var,VAR) pretty-prints the content of a variable VAR on
 # one line
 define echo-var
-@printf "%15s = %s\n" "$(1)" "$($(1))"
+@printf "%15s = %s\n" '$(1)' '$($(1))'
 endef
 
 # $(call echo-title,TITLE) pretty-prints TITLE as a title
 define echo-title
-@printf "** %s\n" "$(1)"
-endef
-
-# $(call print-command, CMD, TGT) prints a message
-define print-command
-@printf "%15s %s\n" "$(strip $(1))" "$(strip $(2))"
+@printf "** %s\n" '$(1)'
 endef
 
 # $(call C, CMD) runs $(CMD) silently
 define C
-@$(call print-command, $(1), "$(@)")
-@quiet ()                                                            \
-{                                                                    \
-    local cmd out err ;					             \
-    cmd="$($(1))";                                                   \
-    out=$$($${cmd} "$${@}" 2>&1) ;                                   \
-    err=$${?} ;                                                      \
-    if test $${err} -gt 0 ; then                                     \
-        echo "******* Offending Command:";                           \
-        printf "%s" "$${cmd}" ;                                      \
-	for i in "$${@}" ; do printf " '%s'" "$$i" ; done ;          \
-	echo ;                                                       \
-        echo "******* Error Code: $${err}";                          \
-	echo "******* Command Output:";                              \
-        echo "$${out}";                                              \
-    fi;                                                              \
-    echo "$${out}" | grep [Ww]arning ;                               \
-    return $${err};                                                  \
-} ; quiet
+@printf "%15s %s\n" '$(1)' '$(@)'
+$(Q)"$($(1))"
 endef
 
 # If verbose print everything
 ifdef VERB
-C = $($(1))
-endif
+Q=
+else
+Q=@
+endif
+
+# Greater or equal: returns the empty string if $1 >= $2, otherwise returns 'false',
+# where the arguments are integer numbers
+gt = $(shell if [ "$(1)" -lt "$(2)" ] ; then echo false ; fi)
 
 # rule to create a directory
 .PRECIOUS: %/.dirstamp
@@ -290,15 +321,15 @@
 # inclued by make as auto-dependencies) and the list of files to be
 # added to the binary distribution.
 
+.PHONY: clean, archclean, distclean, info, help
+no_dep_targets := clean archclean distclean info help
+
 include make/dll.mak
 include make/bin.mak
 include make/matlab.mak
 include make/octave.mak
 include make/doc.mak
 include make/dist.mak
-
-.PHONY: clean, archclean, distclean, info, help
-no_dep_targets += clean archclean distclean info help
 
 clean:
 	rm -f  `find . -name '*~'`
@@ -319,6 +350,8 @@
 	$(call echo-var,VER)
 	$(call echo-var,ARCH)
 	$(call echo-var,CC)
+	$(call echo-var,COMPILER)
+	$(call echo-var,COMPILER_VER)
 	$(call echo-var,STD_CFLAGS)
 	$(call echo-var,STD_LDFLAGS)
 	$(call echo-var,DISABLE_SSE2)

=== debian/changelog ===
vlfeat (0.9.20+dfsg0-2) unstable; urgency=medium

  * Team upload.
  * Build-depend on dh-octave instead of octave-pkg-dev.
    Thanks to Rafael Laboissière (Closes: #890085)
  * Update Vcs-* fields for salsa.
  * Bump packages from priority extra to optional.
  * Also missing files to clean rule: *.o, VERSION, toolbox/{mex,noprefix}.

 -- Sébastien Villemot <sebastien@debian.org>  Tue, 13 Feb 2018 12:48:31 +0100

vlfeat (0.9.20+dfsg0-1) unstable; urgency=medium

  * New upstream release

 -- Dima Kogan <dima@secretsauce.net>  Mon, 31 Aug 2015 00:05:46 -0700

vlfeat (0.9.19+dfsg0-1) experimental; urgency=medium

  [ Dima Kogan ]
  * New upstream release
  * Handling new target path behavior of mkoctfile. (Closes: #756222)

  [ Anton Gladky ]
  * Removed mathjax from the docs.
  * Replace BSD by BSD-2-clause in d/copyright.
  * Set Standards-Version: 3.9.6. No changes.

 -- Dima Kogan <dima@secretsauce.net>  Thu, 16 Oct 2014 14:38:32 -0700

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,17 @@
 Source: vlfeat
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 9), dh-exec, liboctave-dev, octave-pkg-dev (>= 1.0.0),
-               transfig, ghostscript, inkscape, texlive-latex-base, imagemagick,
-               python2.7, doxygen, rsync
+Build-Depends: debhelper (>= 9), dh-exec, liboctave-dev, dh-octave,
+               transfig, ghostscript, librsvg2-bin, texlive-latex-base, imagemagick,
+               python2.7, doxygen, rsync, groff
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Dima Kogan <dima@secretsauce.net>
-Standards-Version: 3.9.4
+Standards-Version: 3.9.6
 Homepage: http://www.vlfeat.org
-Vcs-Git: git://anonscm.debian.org/debian-science/packages/vlfeat.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/vlfeat.git
+Vcs-Git: https://salsa.debian.org/science-team/vlfeat.git
+Vcs-Browser: https://salsa.debian.org/science-team/vlfeat
 
-Package: libvlfeat0
+Package: libvlfeat1
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -28,7 +28,7 @@
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
-Depends: ${misc:Depends}, libvlfeat0 (= ${binary:Version})
+Depends: ${misc:Depends}, libvlfeat1 (= ${binary:Version})
 Recommends: libvlfeat-doc
 Description: Computer vision library focussing on visual features and clustering
  VLFeat implements popular computer vision algorithms including SIFT, MSER,
@@ -38,12 +38,11 @@
  .
  Development files
 
-Package: libvlfeat0-dbg
+Package: libvlfeat1-dbg
 Section: debug
-Priority: extra
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, libvlfeat0 (= ${binary:Version})
+Depends: ${misc:Depends}, libvlfeat1 (= ${binary:Version})
 Description: Computer vision library focussing on visual features and clustering
  VLFeat implements popular computer vision algorithms including SIFT, MSER,
  k-means, hierarchical k-means, agglomerative information bottleneck, and quick
@@ -66,11 +65,10 @@
 
 Package: octave-vlfeat
 Section: libs
-Priority: extra
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}, libvlfeat0 (>= ${binary:Version}),
+Depends: ${shlibs:Depends}, ${misc:Depends}, libvlfeat1 (>= ${binary:Version}),
          ${octave:Depends}
 Recommends: libvlfeat-doc
 Description: Computer vision library focussing on visual features and clustering

=== debian/rules ===
--- 
+++ 
@@ -11,7 +11,7 @@
 	dh $@
 
 override_dh_auto_build:
-	make MKOCTFILE=`which mkoctfile` VERB=1 CFLAGS+=-g all doc
+	make PYTHON=python2.7 MKOCTFILE=`which mkoctfile` VERB=1 CFLAGS+=-g all doc
 
 
 override_dh_auto_install: $(addprefix install/,data $(wildcard toolbox/*))
@@ -20,18 +20,19 @@
 	ln -fs libvl.so.$(VERSION) libvl.so.$(API_VERSION)
 
 override_dh_gencontrol:
-	dh_gencontrol -- -V"octave:Depends=octave(>=`octave-config --print VERSION`)"
+	dh_octave_substvar
+	dh_gencontrol
 
 override_dh_strip: strip_mex
-	dh_strip --dbg-package=libvlfeat0-dbg
+	dh_strip --dbg-package=libvlfeat$(API_VERSION)-dbg
 
 override_dh_installdocs:
 	dh_installdocs -Xbuild/
 
 override_dh_auto_clean:
 	dh_auto_clean
-	rm -f libvl.so*
-
+	rm -f VERSION libvl.so* *.o
+	rm -rf toolbox/noprefix/ toolbox/mex/

## vlfeat 0.9.21+dfsg0

=== Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 # description: Build everything
 # author: Andrea Vedaldi
 
-# Copyright (C) 2014 Andrea Vedaldi.
+# Copyright (C) 2014,18 Andrea Vedaldi.
 # Copyright (C) 2007-12 Andrea Vedaldi and Brian Fulkerson.
 # All rights reserved.
 #
@@ -83,7 +83,7 @@
 # components, located in make/*.mak. Please check out the
 # corresponding files in order to adjust parameters.
 
-# Copyright (C) 2014 Andrea Vedaldi.
+# Copyright (C) 2014,18 Andrea Vedaldi.
 # Copyright (C) 2007-13 Andrea Vedaldi and Brian Fulkerson.
 # All rights reserved.
 #
@@ -200,7 +200,8 @@
 
 ifeq "$(COMPILER)" "clang"
 ifneq "$(DISABLE_OPENMP)" "no"
-$(info Clang does not support OpenMP yet, disabling.)
+$(info Apple Clang does not support OpenMP yet, disabling.)
+$(info Alternatively, use brew llvm clang and specify DISABLE_OPENMP=no.)
 DISABLE_OPENMP:=yes
 endif
 endif
@@ -322,7 +323,7 @@
 # added to the binary distribution.
 
 .PHONY: clean, archclean, distclean, info, help
-no_dep_targets := clean archclean distclean info help
+no_dep_targets := clean archclean distclean help
 
 include make/dll.mak
 include make/bin.mak
@@ -379,6 +380,6 @@
 
 .PRECIOUS: $(deps)
 
-ifeq ($(filter $(no_dep_targets), $(MAKECMDGOALS)),)
+ifneq ($(filter-out $(no_dep_targets), $(MAKECMDGOALS)),)
 -include $(deps)
 endif

=== debian/changelog ===
vlfeat (0.9.21+dfsg0-7build1) jammy; urgency=medium

  * No-change rebuild against octave 6.4.0

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 19 Jan 2022 09:39:05 +0000

vlfeat (0.9.21+dfsg0-7) unstable; urgency=medium

  * Fixed build error (Closes: #991066). Thanks to Dennis Filder
    <d.filder@web.de> for the patch
  * Fixed debian/watch

 -- Dima Kogan <dkogan@debian.org>  Thu, 11 Nov 2021 10:27:08 -0800

vlfeat (0.9.21+dfsg0-6) unstable; urgency=medium

  * Team upload.
  * Source-only upload following trip through NEW.

 -- Stuart Prescott <stuart@debian.org>  Sat, 08 Feb 2020 16:39:32 +1100

vlfeat (0.9.21+dfsg0-5) unstable; urgency=medium

  * Team upload.
  * Build-depend on Python 3 instead of Python 2 (Closes: #938791).
    - use 2to3 to update documentatation producing code
    - fix whitespace in Python code
    - fix bytes/str handling in XML processing
  * Build-depend on pygments for syntax highlighting of source code
    in documentation.

 -- Stuart Prescott <stuart@debian.org>  Tue, 21 Jan 2020 23:34:20 +1100

vlfeat (0.9.21+dfsg0-4) unstable; urgency=medium

  * Fixed build with gcc-9 (Closes: #925853)

 -- Dima Kogan <dkogan@debian.org>  Thu, 12 Dec 2019 22:36:05 -0800

vlfeat (0.9.21+dfsg0-3) unstable; urgency=medium

  * Added forgotten Breaks tag (Closes: #901208)

 -- Dima Kogan <dkogan@debian.org>  Mon, 13 Aug 2018 23:05:31 -0700

vlfeat (0.9.21+dfsg0-2) unstable; urgency=medium

  * Added forgotten Replaces tag (Closes: #892047)
  * Fixed FTBFS failures on non-x86 architectures, thanks to Adrian Bunk
    (Closes: #892107).

 -- Dima Kogan <dkogan@debian.org>  Fri, 06 Apr 2018 21:41:15 -0700

vlfeat (0.9.21+dfsg0-1) unstable; urgency=medium

  * New upstream release
  * Added a note highlighting removal of patented code (Closes: #816397)

 -- Dima Kogan <dkogan@debian.org>  Fri, 02 Mar 2018 23:23:30 -0800

=== debian/control ===
Source: vlfeat
Section: science
Priority: optional
Build-Depends: debhelper (>= 11), dh-exec, liboctave-dev, dh-octave,
               transfig, ghostscript, librsvg2-bin, texlive-latex-base, imagemagick,
               python3, python3-pygments, doxygen, rsync, groff
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Dima Kogan <dkogan@debian.org>
Standards-Version: 4.1.3
Homepage: http://www.vlfeat.org
Vcs-Git: https://salsa.debian.org/science-team/vlfeat.git
Vcs-Browser: https://salsa.debian.org/science-team/vlfeat

Package: libvlfeat1
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Computer vision library focussing on visual features and clustering
 VLFeat implements popular computer vision algorithms including MSER, k-means,
 hierarchical k-means, agglomerative information bottleneck, and quick shift. It
 is written in C for efficiency and compatibility, with interfaces in GNU octave
 for ease of use, and detailed documentation throughout. Note that some of the
 upstream library is under patent protection, and those components (SIFT for
 instance) are not included in this package

Package: libvlfeat-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, libvlfeat1 (= ${binary:Version})
Recommends: libvlfeat-doc
Description: Computer vision library focussing on visual features and clustering
 VLFeat implements popular computer vision algorithms including MSER, k-means,
 hierarchical k-means, agglomerative information bottleneck, and quick shift. It
 is written in C for efficiency and compatibility, with interfaces in GNU octave
 for ease of use, and detailed documentation throughout. Note that some of the
 upstream library is under patent protection, and those components (SIFT for
 instance) are not included in this package
 .
 Development files

Package: libvlfeat-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, libjs-mathjax
Replaces: libvlfeat-dev (<< 0.9.21+dfsg0-1)
Breaks: libvlfeat-dev (<< 0.9.21+dfsg0-1)
Description: Computer vision library focussing on visual features and clustering
 VLFeat implements popular computer vision algorithms including MSER, k-means,
 hierarchical k-means, agglomerative information bottleneck, and quick shift. It
 is written in C for efficiency and compatibility, with interfaces in GNU octave
 for ease of use, and detailed documentation throughout. Note that some of the
 upstream library is under patent protection, and those components (SIFT for
 instance) are not included in this package
 .
 Documentation

Package: octave-vlfeat
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, libvlfeat1 (>= ${binary:Version}),
         ${octave:Depends}
Recommends: libvlfeat-doc
Description: Computer vision library focussing on visual features and clustering
 VLFeat implements popular computer vision algorithms including MSER, k-means,
 hierarchical k-means, agglomerative information bottleneck, and quick shift. It
 is written in C for efficiency and compatibility, with interfaces in GNU octave
 for ease of use, and detailed documentation throughout. Note that some of the
 upstream library is under patent protection, and those components (SIFT for
 instance) are not included in this package
 .
 GNU Octave interface

=== debian/rules ===
--- 
+++ 
@@ -1,5 +1,8 @@
 #!/usr/bin/make -f
 # -*- makefile -*-
+
+export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow
+
 
 # grab the version from the debian changelog
 VERSION := $(shell sed -n 's/.*(\([0-9\.]*[0-9]\).*).*/\1/;; p; q;' debian/changelog)
@@ -7,12 +10,16 @@
 # grab the API version from the library SONAME
 API_VERSION = $(shell objdump -p bin/*/libvl.so | perl -ne 'if(/^\s+SONAME\s+libvl.so./p) {print $${^POSTMATCH}; exit;}')
 
+IMAGEMAGICK_POLICY := /etc/$(shell convert -version|sed -n '/^Version: /s@Version: ImageMagick \([[:digit:]]\+\)\..*@ImageMagick-\1@p')/policy.xml
+
 %:
 	dh $@
 
 override_dh_auto_build:
-	make PYTHON=python2.7 MKOCTFILE=`which mkoctfile` VERB=1 CFLAGS+=-g all doc
-
+	mkdir -p debian/tmp/ImageMagick
+	sed -e '/<policy domain="coder" rights="none" pattern="PDF" .>/s@"none"@"read|write"@' "$(IMAGEMAGICK_POLICY)" > debian/tmp/ImageMagick/policy.xml
+	make XDG_CONFIG_HOME="$(shell pwd)/debian/tmp" PYTHON=python3 MKOCTFILE=`which mkoctfile` VERB=1 CFLAGS+=-g all doc
+	rm -Rf debian/tmp/ImageMagick
 
 override_dh_auto_install: $(addprefix install/,data $(wildcard toolbox/*))
 	cp bin/*/libvl.so libvl.so.$(VERSION)
@@ -24,7 +31,7 @@
 	dh_gencontrol
 
 override_dh_strip: strip_mex
-	dh_strip --dbg-package=libvlfeat$(API_VERSION)-dbg
+	dh_strip --dbgsym-migration='libvlfeat$(API_VERSION)-dbg (<< 0.9.21+dfsg0-1~)'
 
 override_dh_installdocs:
 	dh_installdocs -Xbuild/
@@ -43,7 +50,7 @@
 include /usr/share/octave/debian/defs.make
 
 
-# I want to take all the *.m in toolbox/xxx/ for all xxx except mex and
+# I want to take all the *.m in toolbox/xxx/ for all xxx except mex and doc and
 # noprefix. I want to take only some particular toolbox/*.m. There are many
 # other files strewn around that I want to ignore. This is somewhat
 # convoluted...
@@ -72,7 +79,7 @@
 override_dh_compress:
 	dh_compress -X.m
 
-$(filter-out %.m install/data install/toolbox/mex install/toolbox/noprefix,$(OCTAVE_PHONY_TARGETS)):
+$(filter-out %.m install/data install/toolbox/mex install/toolbox/doc install/toolbox/noprefix,$(OCTAVE_PHONY_TARGETS)):
 	if [ -d $(OCT_TARGET) ]; then							\
 		install -d $(OCTAVE_MPATH);						\
 		install -d $(OCTAVE_MPATH)/$(notdir $(OCT_TARGET));			\

=== debian/watch ===
version=4
opts=dversionmangle=s/(?:\+dfsg|\+repack).*$//,\
filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/vlfeat-$1\.tar\.gz/ \
  https://github.com/vlfeat/vlfeat/tags .*/v?(\d\S+)\.tar\.gz
